clear all; close all;

%---------------------------------------------

f = ;
y_exakt = ;
tspan = ;
ya = ;    

%---------------------------------------------

Nstart=10;
step=5; %max. Schritte: Nstart*2^step
% Was passiert ab step=9?
M=5;

%---------------------------------------------

%fuer Fehlerplot
type=['ks- ';'r+- '; 'bs- ';'co- ';'go- '; 'mx- '; 'c>- '; 'r<- '; 'g^--';...
     'bv--'; 'co--'; 'm+--';'r*: '; 'gx: '; 'bs: '; 'cd: '; 'mo: '];
 
%---------------------------------------------

yex = y_exakt(tspan(2)); 

eN1 = zeros(1,step+1);
eN2 = zeros(1,step+1);
eN3 = zeros(1,step+1);

number_N=zeros(1,step+2); % aufgrund der Schleife berechne ich eines zuviel!
number_N(1)=Nstart;

%---------------------------------------------

for i=1:step+1 
   %Starte ADB mit exakten Startwerten
   [yN1,tN1] = ;
   eN1(i)=norm(yN1(:,end)-yex);  
   %Starte ADB mit klassischem RK 4.Ordnung fuer Startwerte
   [yN2,tN2] = ;
   eN2(i)=norm(yN2(:,end)-yex); 
   %Starte ADB mit expliziten Euler fuer Startwerte
   [yN3,tN3] = ;
   eN3(i)=norm(yN3(:,end)-yex);
   
   number_N(i+1)=2*number_N(i);
end

%---------------------------------------------

%Gebe die Ergebnisse aus
fprintf('\n  N      h       ||yh(1)-y(1)||     Konv.ord.');
fprintf('\n---------------------------------------------');
fprintf('\n');
fprintf('\nABV 1: Mit exakten Startwerten:');      
fprintf('\n%3d %9.6f %18.10e %11.6f',...
         [number_N(1:step+1); (1./number_N(1:step+1)); eN1;...
         [NaN log(eN1(1:step)./eN1(2:step+1))/log(2)]]);
fprintf('\n');
fprintf('\nABV 2: Mit Startwerten aus Runge-Kutta 4.Ordnung:');      
fprintf('\n%3d %9.6f %18.10e %11.6f',...
         [number_N(1:step+1); (1./number_N(1:step+1)); eN2;...
         [NaN log(eN2(1:step)./eN2(2:step+1))/log(2)]]);
     
fprintf('\n');
fprintf('\nABV 3: Mit Startwerten aus explizitem Euler:');      
fprintf('\n%3d %9.6f %18.10e %11.6f',...
         [number_N(1:step+1); (1./number_N(1:step+1)); eN3;...
         [NaN log(eN3(1:step)./eN3(2:step+1))/log(2)]]);

fprintf('\n');
fprintf('\nExakte Loesung:   %18.10e',yex);
fprintf('\nyh(1), ABV 1 :    %18.10e',yN1(:,end));
fprintf('\nyh(1), ABV 2 :    %18.10e',yN2(:,end));
fprintf('\nyh(1), ABV 3 :    %18.10e',yN3(:,end));
fprintf('\n');

loglog(number_N(1:step+1),eN1,art(1,:));
hold on;
loglog(number_N(1:step+1),eN2,art(2,:));
hold on;
loglog(number_N(1:step+1),eN3,art(3,:));
title('Vergleich der Fehlerkurven');

bwLegend(2.4,-0.5,-4,art(1:3,:),['ABV 1'; 'ABV 2'; 'ABV 3']);
loglogTriangle(20,300,10^(-2.5), 2,'l');
loglogTriangle(20,300,10^(-6), 4,'l');
xlabel('Anzahl der Schritte');
ylabel('Fehler');
hold off;

 