%% Dreikoerper-Problem

%Zeitraum festlegen
T = 17.06521656015796255889;
tspan = [0, T];

% Anfangsbedingung setzen
y0 = [0.994;0;0;-2.0015851063790825];

% The function for the right hand side has to be written!!!
f=@dreikoerper_rhs;

mu = 0.012277471;
mu_hat = 1-mu;
tol=1e-7;

[t,y] = RK78(f,[tspan(1),tspan(2)],y0,tol);
plot(y(1,:), y(3,:),'b-*', -mu,0, 'ro', mu_hat,0, 'ro')
title('Arenstorf-Orbit with RK7(8)')
axis([-1.5 1.5 -1.5 1.5])
text( -mu-0.1 ,-0.1,'Sun','fontsize',8);
text(  mu_hat-0.1 ,-0.1,'Moon','fontsize',8);


% Don’t forget to apply the explicit Euler-method!




%% Example (iv) - Davis Skodje

y0 = [1;1];
t0=0;
tN=1;

E=[1e-2,1e-3,1e-4];


epsilon=E(1);

f=@(t,y) [-y(1);-(1/epsilon)*y(2)+y(1)/(epsilon*(1+y(1)))-y(1)/((1+y(1))^2)];

[t,y] = RK78(f,[t0,tN],y0);
figure(1)
plot(t,y)
s = 'RK7(8) - Davis-Skodje';
legend('u(t)' , 'v(t)')
title(s)
